//---------------------------------------------------------------------------
// FORMULARIO PRINCIPAL
// PRACTICA FotoPain, versin 2009
// Procesamiento Audiovisual, 3 II, ITIS
// Universidad de Murcia, GinesGM
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
#include "Unit4.h"
#include "Unit5.h"
#include "Unit7.h"
#include "Unit8.h"
#include "Unit10.h"
#include "Unit11.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  inic_fotos();
}
//---------------------------------------------------------------------------

void SetStatusBar1 (int masfotos)
{
  static int nfotos= 0;
  nfotos+= masfotos;
  AnsiString st= nfotos;
  st+= " imgenes";
  Form1->StatusBar1->SimpleText= st;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Lneas1Click(TObject *Sender)
{
   SpeedButton6->Down= true;
   herr_actual= lineas;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Puntos1Click(TObject *Sender)
{
   SpeedButton5->Down= true;
   herr_actual= puntos;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Seleccionar1Click(TObject *Sender)
{
   SpeedButton4->Down= true;
   herr_actual= seleccionar;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N1Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Nuevo1Click(TObject *Sender)
{
  int pl= primera_libre();
  if (pl==-1)
    ShowMessage("Lo siento. No se pueden crear ms ventanas.");
  else
    if (Form3->Execute()) {
      TColor tc= Form3->cbFondo->Selected;
      CvScalar color= CV_RGB(tc&0xff, (tc&0xff00)>>8, (tc&0xff0000)>>16);
      crear_nueva(pl, Form3->csAnchura->Value, Form3->csAltura->Value, color);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{
  radio_pincel= TrackBar1->Position;      
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Abrir1Click(TObject *Sender)
{
  int pl= primera_libre();
  if (pl==-1)
    ShowMessage("Lo siento. No se pueden crear ms ventanas.");
  else
    if (OpenDialog1->Execute())
      crear_nueva(pl, OpenDialog1->FileName.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Invertir1Click(TObject *Sender)
{
  int pl= primera_libre();
  if (pl==-1)
    ShowMessage("Lo siento. No se pueden crear ms ventanas.");
  else
    invertir(pl);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Rotar1Click(TObject *Sender)
{
  int pl= primera_libre();
  if (pl==-1)
    ShowMessage("Lo siento. No se pueden crear ms ventanas.");
  else
    rotar_90(pl);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Rotar901Click(TObject *Sender)
{
  int pl= primera_libre();
  if (pl==-1)
    ShowMessage("Lo siento. No se pueden crear ms ventanas.");
  else
    rotar_m90(pl);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Colordelpincel1Click(TObject *Sender)
{
  if (ColorDialog1->Execute()) {
    TColor col= ColorDialog1->Color;
    Shape1->Brush->Color= col;
    color_pincel= CV_RGB(col&0xff, (col&0xff00)>>8, (col&0xff0000)>>16);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Shape1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  Colordelpincel1Click(Sender);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Brillocontraste1Click(TObject *Sender)
{
  int pl= primera_libre();
  if (pl==-1)
    ShowMessage("Lo siento. No se pueden crear ms ventanas.");
  else {
    int fa= foto_activa();
    if (fa!=-1)
      Form4->Execute(fa);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Guardar1Click(TObject *Sender)
{
  int fa= foto_activa();
  if (fa!=-1) {
    SaveDialog1->FileName= foto[fa].nombre;
    if (SaveDialog1->Execute())
      guardar_foto(fa, SaveDialog1->FileName.c_str());
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  while (foto_activa()!=-1)
    Cerrar1Click(Sender);
  fin_fotos();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Cerrar1Click(TObject *Sender)
{
  int fa= foto_activa();
  if (fa!=-1) {
    if (foto[fa].modificada && preguntar_guardar) {
      AnsiString nombre= foto[fa].nombre;
      int resp= MessageDlg("El archivo " + nombre + " ha sido modificado.\nDesea guardarlo?",
               mtInformation, TMsgDlgButtons() << mbYes	<< mbNo << mbCancel, 0);
      if (resp==mrYes)
        Guardar1Click(Sender);
      else if (resp==mrCancel)
        return;
    }
    cerrar_foto(fa);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Seleccionartodo1Click(TObject *Sender)
{
  int fa= foto_activa();
  if (fa!=-1) {
    foto[fa].roi= cvRect(-1, -1, -1, -1);
    mostrar(fa);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Suavizadogausiano1Click(TObject *Sender)
{
  int fa= foto_activa();
  if (fa!=-1)
    Form5->Execute(fa, 0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Suavizadomedia1Click(TObject *Sender)
{
  int fa= foto_activa();
  if (fa!=-1)
    Form5->Execute(fa, 1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Mediaponderada1Click(TObject *Sender)
{
  int fa= foto_activa(), pl= primera_libre();
  if (fa!=-1)
    if (pl==-1)
      ShowMessage("Lo siento. No se pueden crear ms ventanas.");
    else {
      if (Form7->Execute(fa))
        media_ponderada(Form7->nfoto1, Form7->nfoto2, pl, Form7->peso/100.0);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Acercade1Click(TObject *Sender)
{
  AboutBox->Show();      
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar2Change(TObject *Sender)
{
  difum_pincel= TrackBar2->Position;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Rotarimagen2Click(TObject *Sender)
{
  int fa= foto_activa();
  if (fa!=-1)
    Form10->Execute(fa);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Unir1Click(TObject *Sender)
{
  Form11->Show();
}
//---------------------------------------------------------------------------
  
void __fastcall TForm1::Preguntarguardar1Click(TObject *Sender)
{
  Preguntarguardar1->Checked= !Preguntarguardar1->Checked;
  preguntar_guardar= Preguntarguardar1->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Suavizadomediana1Click(TObject *Sender)
{
  int fa= foto_activa();
  if (fa!=-1)
    Form5->Execute(fa, 2);
}
//---------------------------------------------------------------------------

